var crypto = require('crypto');
const algorithm = 'aes-256-cbc';

function ndpsencrypt(data) {
    var final = (new Buffer.from(data['clientcode']).toString('base64'));
    var url = data['ru'] == "" ? null : data['ru'];
    var udf1 = data['udf1'] == "" ? null : data['udf1'];
    var udf2 = data['udf2'] == "" ? null : data['udf2'];
    var udf3 = data['udf3'] == "" ? null : data['udf3'];
    var udf4 = data['udf4'] == "" ? null : data['udf4'];
    var key = data['encHashKey'];
    var req_enc_key = data['encRequestKey'];
    var req_salt = data['encRequestKey'];

    var sign = data['loginid'] + data['password'] + data['ttype'] + data['productid'] + data['transactionsid'] + data['amount'] + data['txncurrency'];

    function sig(sign, key) {
        var signature = crypto.createHmac('sha512', key)
            .update(new Buffer.from(sign, 'utf-8'))
            .digest('hex');
        return signature;
    }

    var signature = sig(sign, key);

    var text = 'login=' + data['loginid'] + '&pass=' + data['password'] + '&ttype=' + data['ttype'] + '&prodid=' + data['productid'] + '&amt=' + data['amount'] + '&txncurr=' + data['txncurrency'] + '&txnscamt=' + data['amount'] + '&clientcode=' + encodeURIComponent(final) + '&txnid=' + data['transactionsid'] + '&date=' + data['date'] + '&custacc=' + data['custacc'] + '&udf1=' + udf1 + '&udf2=' + udf2 + '&udf3=' + udf3 + '&udf4=' + udf4 + '&ru=' + url + '&signature=' + signature;

    const password = Buffer.from(req_enc_key, 'utf8');
    const salt = Buffer.from(req_salt, 'utf8');
    const iv = Buffer.from([0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15], 'utf8');

    const encrypt = (text) => {
        var derivedKey = crypto.pbkdf2Sync(password, salt, 65536, 32, 'sha1');
        const cipher = crypto.createCipheriv(algorithm, derivedKey, iv);
        let encrypted = cipher.update(text);
        encrypted = Buffer.concat([encrypted, cipher.final()]);
        return `${encrypted.toString('hex')}`;
    };

    var encdata = encrypt(text);
    url = data['payUrl'] + '?login=' + data['loginid'] + '&encdata=' + encdata.toUpperCase();
    return url;
}

function ndpsresponse(data) {
    var res_enc_key = data['decResponseKey'];
    var res_salt = data['decResponseKey'];
    const password = Buffer.from(res_enc_key, 'utf8');
    const salt = Buffer.from(res_salt, 'utf8');
    const iv = Buffer.from([0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15], 'utf8');
    const decrypt = (text) => {
        const encryptedText = Buffer.from(text, 'hex');
        var derivedKey = crypto.pbkdf2Sync(password, salt, 65536, 32, 'sha1');
        const decipher = crypto.createDecipheriv(algorithm, derivedKey, iv);
        let decrypted = decipher.update(encryptedText);
        decrypted = Buffer.concat([decrypted, decipher.final()]);
        return decrypted.toString();
    };
    var decrypted_data = decrypt(data['response']);
    var arr = decrypted_data.split("&").map(function (val) {
        return val;
    });
    var data = {};
    for (var i = 0; i < arr.length; i++) {
        var val = arr[i].split('=');
        data[val[0]] = val[1];
    }
    return data;
}

function verifysignature(response, key) {
    var str = response["mmp_txn"] + response["mer_txn"] + response["f_code"] +
        response["prod"] + response["discriminator"] +
        response["amt"] + response["bank_txn"];
    return crypto.createHmac('sha512', key)
        .update(new Buffer.from(str, 'utf-8'))
        .digest('hex');
}

module.exports = {
    ndpsencrypt,
    ndpsresponse,
    verifysignature
}

